<?php
/*
Plugin Name: zed1.com iCal Events Widget
Plugin URI: http://zed1.com/journalized/wordpress-plugins/zed1-ical-events
Description: Add iCal Events as a widget. Requires <a href="http://dev.webadmin.ufl.edu/~dwc/2005/03/10/ical-events-plugin/">iCal Events plugin</a>
Author: Mike Little
Version: 1.0.1
Author URI: http://zed1.com/
*/

/*  Copyright 2008  Mike Little  (email : mike@zed1.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function zed1_iew_control() {
    $options = get_option("widget_zed1_iew");
    if (!is_array($options)) {
        $options = array('title' => 'iCal Events',
                        'num' => 5);
    }
    if ($_POST['zed1_iew_submit']) {
        $options['title'] = htmlspecialchars($_POST['zed1_iew_widget_title']);
        $options['url'] = htmlspecialchars($_POST['zed1_iew_widget_url']);
        $options['num'] = htmlspecialchars($_POST['zed1_iew_widget_num']);
        $options['feed'] = htmlspecialchars($_POST['zed1_iew_widget_feed']);
        $options['feedtitle'] = htmlspecialchars($_POST['zed1_iew_widget_feed_title']);
        update_option("widget_zed1_iew", $options);
    }

    if (!class_exists('ICalEvents')) {
?>
        <p class="error">You don't seem to have the <a href="http://dev.webadmin.ufl.edu/~dwc/2005/03/10/ical-events-plugin/">iCal
          Events plugin</a>, or it is not enabled. This plugin will not do anything useful without it.</p>
<?php
    } // end if class exists

?>
  <p>
    <label for="zed1_iew_widget_title">Widget Title: </label>
    <input type="text" class="widefat" id="zed1_iew_widget_title" name="zed1_iew_widget_title" value="<?php echo $options['title'];?>" />
  </p>
  <p>
    <label for="zed1_iew_widget_url">iCal URL: </label>
    <input type="text" class="widefat" id="zed1_iew_widget_url" name="zed1_iew_widget_url" value="<?php echo $options['url'];?>" />
  </p>
  <p>
    <label for="zed1_iew_widget_num">Number of Entries: </label>
    <input type="text" style="width: 25px; text-align: center;" id="zed1_iew_widget_num" name="zed1_iew_widget_num" value="<?php echo $options['num'];?>" />
  </p>
  <p>
    <label for="zed1_iew_widget_feed_title">Feed Title: </label>
    <input type="text" class="widefat" id="zed1_iew_widget_feed_title" name="zed1_iew_widget_feed_title" value="<?php echo $options['feedtitle'];?>" />
  </p>
  <p>
    <label for="zed1_iew_widget_url">Feed URL: </label>
    <input type="text" class="widefat" id="zed1_iew_widget_feed" name="zed1_iew_widget_feed" value="<?php echo $options['feed'];?>" />
    <input type="hidden" id="zed1_iew_submit" name="zed1_iew_submit" value="1" />
  </p>
<?php
} // end zed1_iew_control

function zed1_iew() {
    if (method_exists('ICalEvents', 'display_events')) {
        $options = get_option("widget_zed1_iew");
        $title = $options['title'];
        $url = $options['url']; 
        $num = intval($options['num']);
        if ($num == 0) $num = 5;
        $feed = $options['feed'];
        $feedtitle = $options['feedtitle'];
        if (empty($feedtitle)) $feedtitle = 'RSS Feed';
        if (isset($url)) {

?>
  <ul>
    <?php
            $events = ICalEvents::get_events($url, time(), null, $num);
            if (empty($events)) {
                $output = '<li>No Events</li>';
            } else {
                $output = '';
                foreach ($events as $event) {
                    $output .= '<li class="vevent">';
                    $output .= '<h3>' ;

                    if ($event['URL']) {
                    $output .= '<a class="url" href="' . $event['URL'] . '">';
                    }
                    $output .= '<span class="summary">' . htmlentities($event['Summary']) . '</span>';
                    if ($event['URL']) {
                        $output .= '</a>';
                    }
                    $output .= '</h3>' ;

                    $output .= '<p><abbr class="dtstart" title="'. strftime('%Y-%m-%dT%H:%M:%S%Z', $event['StartTime']) . '">' ;

                    if (ICalEvents::is_all_day($event['StartTime'], $event['EndTime'])) {
                        $output .= htmlentities(strftime('%a, %b %e', $event['StartTime']));
                    } else {
                        $output .= htmlentities(ICalEvents::format_date_range($event['StartTime'], $event['EndTime'], $event['Untimed'], '%a, %b %e', '%l:%M %p'));
                    }
                    $output .= '</abbr>' ;
                    $output .= ' &mdash; ';

                    if ($event['Location']) {
                        $output .= '<span class="location">' . $event['Location'] . '</span>';
                    }

                    $output .= '</p>';

                    $output .= '</li>' . "\n" ;
                } // end each event
            } // end else got events
            echo $output . "\n";
        } // end if url
        if (isset($feed)) {
?>
      <li><a href="<?php echo $feed; ?>"><?php echo $feedtitle; ?></a></li>
<?php
        } // end if feed
?>
  </ul>
<?php
    } // end if ICalEvents->display_events exists

} // end zed1_iew

function widget_zed1_iew($args) {
    extract($args);

    $options = get_option("widget_zed1_iew");
    if (!is_array( $options )) {
        $options = array('title' => 'iCal Events');
    }

    echo $before_widget;
    echo $before_title;
    echo $options['title'];
    echo $after_title;
    if (!is_admin())
        zed1_iew();
    echo $after_widget;
} // end widget_zed1_iew

function zed1_events_css() {
?>
<style type="text/css">
/* zed1 ical events */
#sidebar .vevent h3{
  font-size: 100%;
  margin: 0;
  padding: 0;
}

#sidebar .vevent abbr {
  margin: 0;
}

#sidebar .vevent p {
  margin: 3px 1px;
  padding: 0;
}

</style>
<?php
} // end zed1_events_css

function zed1_iew_init() {
  register_sidebar_widget('iCal Events', 'widget_zed1_iew');
  register_widget_control('iCal Events', 'zed1_iew_control', null, 200 );
} // end zed1_iew_init

add_action("plugins_loaded", "zed1_iew_init");
add_action("wp_head" , "zed1_events_css");
?>